// Form1.h (Test Server)

#pragma once

#include "Server.h"

namespace TestServer {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Zusammenfassung fr Form1
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
  public:
    Form1(void)  // Test Server
    {
      InitializeComponent();
      //
      //TODO: Konstruktorcode hier hinzufgen.
      //

      if (!Server::Startup(gcnew Action<int>(this, &Form1::ServerStatusReportCallback))) {
        Text += " (non-primary)";
        MessageBox::Show("There's already an instance of the server running. Please use that.",
          Text, MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
      }
      lblGuiThreadId->Text = String::Format("GUI thread ID: {0}", Thread::CurrentThread->ManagedThreadId);
    }

  protected:
    /// <summary>
    /// Verwendete Ressourcen bereinigen.
    /// </summary>
    ~Form1()  // Test Server
    {
      Server::Shutdown();

      if (components)
      {
        delete components;
      }
    }

  private: System::Windows::Forms::Label^  lblGuiThreadId;
  protected: 
  private: System::Windows::Forms::Label^  lblRemoteAccessThreadId;

	private:
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung.
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		void InitializeComponent(void)
		{
      this->lblGuiThreadId = (gcnew System::Windows::Forms::Label());
      this->lblRemoteAccessThreadId = (gcnew System::Windows::Forms::Label());
      this->SuspendLayout();
      // 
      // lblGuiThreadId
      // 
      this->lblGuiThreadId->AutoSize = true;
      this->lblGuiThreadId->Location = System::Drawing::Point(12, 9);
      this->lblGuiThreadId->Name = L"lblGuiThreadId";
      this->lblGuiThreadId->Size = System::Drawing::Size(35, 13);
      this->lblGuiThreadId->TabIndex = 0;
      this->lblGuiThreadId->Text = L"label1";
      // 
      // lblRemoteAccessThreadId
      // 
      this->lblRemoteAccessThreadId->AutoSize = true;
      this->lblRemoteAccessThreadId->Location = System::Drawing::Point(12, 22);
      this->lblRemoteAccessThreadId->Name = L"lblRemoteAccessThreadId";
      this->lblRemoteAccessThreadId->Size = System::Drawing::Size(35, 13);
      this->lblRemoteAccessThreadId->TabIndex = 1;
      this->lblRemoteAccessThreadId->Text = L"label1";
      // 
      // Form1
      // 
      this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
      this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
      this->ClientSize = System::Drawing::Size(292, 48);
      this->Controls->Add(this->lblRemoteAccessThreadId);
      this->Controls->Add(this->lblGuiThreadId);
      this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
      this->MaximizeBox = false;
      this->Name = L"Form1";
      this->Text = L"Remoting Share Test Server";
      this->ResumeLayout(false);
      this->PerformLayout();

    }
#pragma endregion

  // Other member functions

  private:
    void ServerStatusReportCallback(int nThreadId);

	};
}

